import sys

import pygame

from levels import start_game,show_winscreen,show_losescreen

SCALE = 32

WIDTH = 10 * SCALE
HEIGHT = 17 * SCALE

def main():
    """ your app starts here
    """
    pygame.init()
    window = pygame.display.set_mode((WIDTH,HEIGHT))
    clock = pygame.time.Clock()

    font = pygame.font.SysFont("Courier New",16)

##    s = font.render("j",False,(0,0,0),(255,255,255))
##    rs = pygame.transform.scale(s,(s.get_width()*SCALE,s.get_height()*SCALE))
##    window.blit(rs,(0,0))

    # Show title
    bitsurf = font.render("Bitstream",False,(255,255,255),(0,0,0))
    bitrect = bitsurf.get_rect()
    manipsurf = font.render("Manipulators",False,(255,255,255),(0,0,0))
    maniprect = manipsurf.get_rect()
    titlesurf = pygame.Surface((maniprect.width,bitrect.height+maniprect.height))
    titlerect = titlesurf.get_rect()

    bitrect.midbottom = titlerect.center
    maniprect.midtop = titlerect.center
    titlesurf.blit(bitsurf,bitrect)
    titlesurf.blit(manipsurf,maniprect)

    titlesurf = pygame.transform.scale(titlesurf,
                                       (titlerect.width*2,titlerect.height*2))
    titlerect = titlesurf.get_rect()
    titlerect.center = (WIDTH/2,HEIGHT/2)

    start = font.render("Click to start",False,(255,255,255),(0,0,0))
    startrect = start.get_rect()
    startrect.bottomright = (WIDTH,HEIGHT)
    
    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
            elif event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    pygame.quit()
                    sys.exit()
            elif event.type == pygame.MOUSEBUTTONUP and event.button == 1:
                result = start_game(window,clock,font)
                if result:
                    play = show_winscreen(window,clock,font)
                else:
                    play = show_losescreen(window,clock,font)
                if play:
                    window.fill((0,0,0))
                else:
                    pygame.quit()
                    sys.exit()

        window.blit(start,startrect)
        window.blit(titlesurf,titlerect)
        pygame.display.update()
        clock.tick(30)
                
