import random

import pygame

UP,DOWN = 0,1

class Bot(pygame.sprite.Sprite):
    color = (128,128,128)
    health = 1
    def __init__(self,bitstream,position,y,direction):
        pygame.sprite.Sprite.__init__(self)
        self.position = position
        self.y = y
        self.direction = direction
        self.target = None
        self.bitstream = bitstream
        bitstream.bots.append(self)
        image = pygame.Surface((16,16))
        image.set_colorkey((0,0,0))
        pygame.draw.rect(image,self.color,(4,4,8,8))
        pygame.draw.rect(image,self.color,(2,4,12,5))
        pygame.draw.circle(image,(64,64,64),(4,13),3)
        pygame.draw.circle(image,(64,64,64),(12,13),3)
        pygame.draw.rect(image,(8,8,8),(3,12,2,2))
        pygame.draw.rect(image,(8,8,8),(11,12,2,2))
        pygame.draw.rect(image,self.color,(1,0,6,2))
        pygame.draw.rect(image,self.color,(9,0,6,2))
        pygame.draw.rect(image,(64,64,64),(3,2,2,2))
        pygame.draw.rect(image,(64,64,64),(11,2,2,2))
        if self.direction == DOWN:
            image = pygame.transform.flip(image,False,True)
        self.image = pygame.transform.scale(image,(48,48))
        self.rect = pygame.Rect(self.position*40-4,self.y,64,64)
        if hasattr(self,"death") and self.direction == DOWN:
            self.death = pygame.transform.flip(self.death,False,True)
        self.hurtbot = None

    def update(self):
        if self.hurtbot:
            self.hurtbot.image = self.hurtimage
            self.hurtbot = None
        if self.target:
            if self.target < self.position:
                self.position -= 1
            elif self.target > self.position:
                self.position += 1
            elif self.target == self.position:
                self.bitstream[self.target] = 1 - self.bitstream[self.target]
                self.target = None
                for bot in self.bitstream.bots:
                    if bot.position == self.position and bot != self:
                        bot.health -= 1
                        bot.harmed = True
                        self.hurtimage = bot.image
                        bot.image = self.death
                        self.hurtbot = bot
        self.rect = pygame.Rect(self.position*40-4,self.y,64,64)

class PlayerBot(Bot):
    health = 3
    def __init__(self,color,bitstream,position,y):
        self.color = color
        Bot.__init__(self,bitstream,position,y,UP)

class _B():
    bots = []
_dbot = PlayerBot((255,0,0),_B(),0,0)
Bot.death = _dbot.image
del _B,_dbot

class EnemyBot(Bot):
    def __init__(self,difficulty,bitstream,position,y):
        self.difficulty = difficulty
        self.health = difficulty
        self.dead = False
        Bot.__init__(self,bitstream,position,y,DOWN)
        if len(self.bitstream.bots) == 1:
            self.enemybot = 1
        else:
            self.enemybot = 0

    def update(self):
        if not self.target and random.randint(0,9) < self.difficulty:
            if random.randint(0,10) < self.difficulty - 1:
                self.target = self.bitstream.bots[self.enemybot].position
            else:
                self.target = random.randint(0,7)
        Bot.update(self)
        if self.health == 0:
            self.kill()
            self.dead = True
            self.bitstream.bots.remove(self)

