import sys
import random

import pygame

from bots import PlayerBot, EnemyBot
from bitstream import Bitstream

def start_game(window,clock,font):
##    print "Started Game"
##    print test_level(window,clock,font)
    show_curruption_anim(window,clock,font)
    show_instructions(window,clock,font)
    difficulty = 1
    for l in "Bitstream Manipulators":
        if l == "t":
            difficulty += 1
        elif l == " ":
            difficulty += 1
            continue
        target = [int(x) for x in bin(ord("B"))[2:].zfill(8)]
        code = random.randint(0,127)
        bitstream = Bitstream(code,font)
        ebot = EnemyBot(difficulty,bitstream,4,320-64)
        pbot = PlayerBot((0,128,0),bitstream,4,320+17*4)
        bitstream.update()
        newsurface = pygame.Surface(window.get_size())
        newsurface.blit(bitstream.image,bitstream.rect)
        newsurface.blit(ebot.image,ebot.rect)
        newsurface.blit(pbot.image,pbot.rect)
        w = window.copy()
        if l not in "BM":
            for xoffset in range(0,320,10):
                window.blit(w,(-xoffset,0))
                window.blit(newsurface,(320-xoffset,0))
                clock.tick(30)
                pygame.display.update()
        elif l == "B":
            window.blit(pygame.transform.scale(newsurface,(20,34)),(70,238))
            window.blit(pygame.transform.scale(font.render("B",False,(255,255,255),
                                                      (0,0,0)),(20,34)),
                   (300,17*30))
            w.set_at((70,238),(0,0,255))
            xscale = 320.0 / 76.8
            yscale = 17 * 30.0 / 241
            xoffsets = [300,154,104,78,63,52,45,39,35,31,28,26,24,22,21,19]
            yoffsets = [510,263,177,133,107,89,76,67,60,54,49,45,41,38,36,33]
            for z in range(0,16):
                nsurf = pygame.transform.scale(window,(window.get_width()+xoffsets[z],
                                                       window.get_height()+yoffsets[z]))
                window.blit(nsurf,(-xoffsets[z]/xscale,-yoffsets[z]/yscale))
                clock.tick(30)
                pygame.display.update()
        elif l == "M":
            for yoffset in range(0,17*32+1,17):
                window.fill((0,0,0))
                window.blit(w,(0,-yoffset))
                clock.tick(30)
                pygame.display.update()
            for x in range(16):
                for y in range(17*32):
                    pygame.draw.line(window,(random.randint(0,32),)*3,(0,y),(320,y))
                clock.tick(30)
                pygame.display.update()
            for yoffset in range(17*31,0,-17):
                window.fill((0,0,0))
                window.blit(newsurface,(0,yoffset))
                clock.tick(30)
                pygame.display.update()
        result = run_level(window,clock,font,difficulty,[int(x) for x in bin(ord(l))[2:].zfill(8)],bitstream,ebot,pbot)
        if result == "Success":
            continue
        elif result == "Failure":
            return False
    return True

def show_curruption_anim(window,clock,font):
    startwindow = window.copy()
    smallbot = EnemyBot(1,Bitstream(1,font),1,1).image
    bigbot = pygame.transform.scale(smallbot,(240,240))
    for y in range(-240,0,3):
        window.blit(startwindow,(0,0))
        rect = window.blit(bigbot,(40,y))
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
        clock.tick(30)
        pygame.display.update()
    targets = ([(80 + 20*x,255) for x in range(len("BITSTREAM"))]+
               [(50+20*x,289) for x in range(len("MANIPULATORS"))])
    start = rect.center
    for offset in range(100):
        scale = offset / 100.0
        botimg = pygame.transform.scale(smallbot,
                                        (int(smallbot.get_width()*(1-scale)),
                                         int(smallbot.get_height()*(1-scale))))
        brect = botimg.get_rect()
        window.blit(startwindow,(0,0))
        window.blit(bigbot,(40,0))
        for x,y in targets:
            pos = (start[0] - (start[0] - x) * scale,
                   start[1] - (start[1] - y) * scale)
            brect.center = pos
            window.blit(botimg,brect)
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
        clock.tick(30)
        pygame.display.update()
    for y in range(0,-240,-3):
        window.fill((0,0,0))
        if y % 15 == 0:
            b = [random.randint(0,255) for x in range(len("BITSTREAM"))]
            m = [random.randint(0,255) for x in range(len("MANIPULATORS"))]
        bitstring = "".join(chr(x) if 32 <= x < 127 else " " for x in b)
        manipstring = "".join(chr(x) if 32 <= x < 127 else " " for x in m)
        bitsurf = font.render(bitstring,False,(255,255,255),(0,0,0))
        bitrect = bitsurf.get_rect()
        manipsurf = font.render(manipstring,False,(255,255,255),(0,0,0))
        maniprect = manipsurf.get_rect()
        for x in range(len(bitstring)):
            if b[x] < 32 or b[x] == 127:
                for x in range(10):
                    bitsurf.set_at((random.randint(x*10,x*10+9),
                                    random.randint(0,16)),
                                   (128,182,128))
        for x in range(len(manipstring)):
            if m[x] < 32 or m[x] == 127:
                for x in range(10):
                    manipsurf.set_at((random.randint(x*10,x*10+9),
                                      random.randint(0,16)),
                                     (128,182,128))
        titlesurf = pygame.Surface((maniprect.width,bitrect.height+maniprect.height))
        titlerect = titlesurf.get_rect()

        bitrect.midbottom = titlerect.center
        maniprect.midtop = titlerect.center
        titlesurf.blit(bitsurf,bitrect)
        titlesurf.blit(manipsurf,maniprect)

        titlesurf = pygame.transform.scale(titlesurf,
                                           (titlerect.width*2,titlerect.height*2))
        titlerect = titlesurf.get_rect()
        titlerect.center = window.get_rect().center
        window.blit(titlesurf,titlerect)
        window.blit(bigbot,(40,y))
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
        clock.tick(30)
        pygame.display.update()
        
def show_instructions(window,clock,font):
    startwindow = window.copy()
    thissurf = pygame.Surface(startwindow.get_size()).convert_alpha()
    thissurf.fill((64,64,64,64))
    for y in range(32*17,0,-17):
        window.blit(startwindow,(0,0))
        window.blit(thissurf,(0,-y))
        clock.tick(30)
        pygame.display.update()
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
    text = []
    current_line = []
    with open("data/instructions.txt") as info:
        for byte in info.read():
            if byte == "\n":
                text.append(current_line)
                current_line = []
            else:
                current_line.append(byte)
    textlines = []
    textsurfs = []
    for line in text:
        textsurfs.append(pygame.Surface((0,0)))
        textlines.append("")
        for byte in line:
            textlines[-1] += byte
            textsurfs[-1] = font.render(textlines[-1],False,(255,255,255))
            thissurf.fill((64,64,64,128))
            for y,line in enumerate(textsurfs):
                thissurf.blit(line,(0,y*17))
            window.blit(startwindow,(0,0))
            window.blit(thissurf,(0,0))
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    pygame.quit()
                    sys.exit()
            clock.tick(30)
            pygame.display.update()
    nextsurf = font.render("Play",False,(255,255,255),(0,0,0))
    nextbutton = pygame.transform.scale(nextsurf,(nextsurf.get_width()*2,
                                                  nextsurf.get_height()*2))
    nextrect = nextbutton.get_rect()
    nextrect.bottomright = window.get_size()
    window.blit(nextbutton,nextrect)
    clicked = False
    while not clicked:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
            elif event.type == pygame.MOUSEBUTTONDOWN and event.button == 1:
                if nextrect.collidepoint(event.pos):
                    clicked = True
        clock.tick(30)
        pygame.display.update()
    for y in range(0,33*17,17):
        window.blit(startwindow,(0,0))
        window.blit(thissurf,(0,-y))
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
        clock.tick(30)
        pygame.display.update()

def run_level(window,clock,font,difficulty,target,bitstream,ebot,pbot):
    g = pygame.sprite.OrderedUpdates(bitstream,pbot,ebot)
    g.draw(window)
    pygame.display.update()
    while True:
        if ebot.dead and bitstream.code == target:
            return "Success"
        elif pbot.health == 0:
            return "Failure"
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
            elif event.type == pygame.MOUSEBUTTONDOWN and event.button == 1:
                for b in range(8):
                    if bitstream.bitrects[b].collidepoint(event.pos):
                        pbot.target = b
                        break
        g.update()
        bitstream.update()
        g.draw(window)
        for x in range(ebot.health):
            pygame.draw.polygon(window,(255,255,255),((x*10+5,5),(x*10+1,9),
                                                      (x*10+5,13),(x*10+9,9)),1)
            pygame.draw.circle(window,(255,255,255),(x*10+3,7),3,1)
            pygame.draw.circle(window,(255,255,255),(x*10+7,7),3,1)
            pygame.draw.polygon(window,(0,0,0),((x*10+4,5),(x*10+5,6),(x*10+6,5),
                                                (x*10+8,9),(x*10+5,12),(x*10+1,8)))
        for x in range(pbot.health):
            pygame.draw.polygon(window,(255,255,255),((x*10+5,507),(x*10+1,511),
                                                      (x*10+5,515),(x*10+9,511)),1)
            pygame.draw.circle(window,(255,255,255),(x*10+3,509),3,1)
            pygame.draw.circle(window,(255,255,255),(x*10+7,509),3,1)
            pygame.draw.polygon(window,(255,0,0),((x*10+4,507),(x*10+5,508),(x*10+6,507),
                                                (x*10+8,511),(x*10+5,514),(x*10+1,510)))
        targettext = bitstream.font.render("Target: "+chr(int("".join(str(x) for x in target),2)),
                                           False,(255,255,255))
        trect = targettext.get_rect()
        trect.right = 320
        window.blit(targettext,trect)
        clock.tick(2)
        pygame.display.update()

class Buttonstream(Bitstream):
    def update(self):
        self.value = None
        s1 = self.font.render("Play Again",False,(255,255,255),(0,0,0))
        s2 = self.font.render("Quit",False,(255,255,255),(0,0,0))
        self.image = pygame.Surface((320,s1.get_height()))
        self.bitrects = {}
        self.bitrects[0.5] = self.image.blit(s1,(0,0)).move(0,320)
        r2 = s2.get_rect()
        r2.right = 320
        self.bitrects[6.5] = self.image.blit(s2,r2).move(0,320)
        self.rect = pygame.Rect((0,320),self.image.get_size())

    def __getitem__(self,index):
        if index == 0.5:
            self.value = "Play Again"
        elif index == 6.5:
            self.value = "Quit"
        return 1
    def __setitem__(self,index,value): pass

def show_endscreen(window,clock,font,message):
    bstream = Buttonstream(1,font)
    bot = PlayerBot((0,192,0),bstream,3.5,340)
    window.fill((0,0,0))
    s1 = font.render("You",False,(255,255,255),(0,0,0))
    s2 = font.render(message+"!",False,(255,255,255),(0,0,0))
    surf = pygame.Surface((max(s1.get_width(),s2.get_width()),
                           s1.get_height()+s2.get_height()))
    surfrect = surf.get_rect()
    r1 = s1.get_rect()
    r2 = s2.get_rect()
    r1.midbottom = r2.midtop = surfrect.center
    surf.blit(s1,r1)
    surf.blit(s2,r2)
    scale = 320.0 / max(surfrect.width,surfrect.height)
    bigsurf = pygame.transform.scale(surf,(int(surfrect.width*scale),
                                           int(surfrect.height*scale)))
    surfrect.width *= scale
    surfrect.centerx = 160
    window.blit(bigsurf,surfrect)
    pygame.display.update()
    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
            elif event.type == pygame.MOUSEBUTTONDOWN and event.button == 1:
                for r in bstream.bitrects:
                    if bstream.bitrects[r].collidepoint(event.pos):
                        bot.target = r
        pygame.draw.rect(window,(0,0,0),bot.rect)
        bstream.update()
        bot.update()
        if bstream.value == "Play again":
            return True
        elif bstream.value == "Quit":
            return False
        window.blit(bstream.image,bstream.rect)
        window.blit(bot.image,bot.rect)
        clock.tick(2)
        pygame.display.update()

def show_winscreen(window,clock,font):
    return show_endscreen(window,clock,font,"Win")
def show_losescreen(window,clock,font):
    return show_endscreen(window,clock,font,"Lose")
